--- a/libmariadb/mariadb_config/CMakeLists.txt
+++ b/libmariadb/mariadb_config/CMakeLists.txt
@@ -52,10 +52,6 @@
 
 ADD_EXECUTABLE(mariadb_config ${CMAKE_CURRENT_BINARY_DIR}/mariadb_config.c)
 
-IF(CMAKE_SYSTEM_NAME MATCHES AIX)
-  TARGET_LINK_LIBRARIES(mariadb_config compat-getopt)
-ENDIF()
-
 # Installation
 #
 INSTALL(TARGETS mariadb_config