--- ./.bundle/gems/rdoc-7.0.4/lib/rdoc/ri/paths.rb_orig	2026-01-23 04:30:11.145631641 -0600
+++ ./.bundle/gems/rdoc-7.0.4/lib/rdoc/ri/paths.rb	2026-01-23 04:30:32.154553535 -0600
@@ -10,7 +10,7 @@
   #:stopdoc:
   require 'rbconfig'
 
-  version = RbConfig::CONFIG['ruby_version']
+  version = RbConfig::CONFIG['ruby_version_dir_name'] || RbConfig::CONFIG['ruby_version']
 
   BASE    = File.join RbConfig::CONFIG['ridir'], version
 
--- ./test/rubygems/test_gem.rb_orig	2026-01-23 04:31:34.561032943 -0600
+++ ./test/rubygems/test_gem.rb	2026-01-23 04:33:25.742507480 -0600
@@ -1339,7 +1339,8 @@
 
   def test_self_user_dir
     parts = [@userhome, ".gem", Gem.ruby_engine]
-    parts << RbConfig::CONFIG["ruby_version"] unless RbConfig::CONFIG["ruby_version"].empty?
+    ruby_version_dir_name = RbConfig::CONFIG['ruby_version_dir_name'] || RbConfig::CONFIG['ruby_version']
+    parts << ruby_version_dir_name unless ruby_version_dir_name.empty?
 
     FileUtils.mkdir_p File.join(parts)
 
@@ -1415,7 +1416,7 @@
     vendordir(File.join(@tempdir, "vendor")) do
       expected =
         File.join RbConfig::CONFIG["vendordir"], "gems",
-                  RbConfig::CONFIG["ruby_version"]
+                  RbConfig::CONFIG['ruby_version_dir_name'] || RbConfig::CONFIG['ruby_version']
 
       assert_equal expected, Gem.vendor_dir
     end
--- ./tool/rbinstall.rb_orig	2026-01-23 04:31:44.978025123 -0600
+++ ./tool/rbinstall.rb	2026-01-23 04:36:13.041462695 -0600
@@ -1053,7 +1053,7 @@
 
 install?(:doc, :rdoc) do
   if $rdocdir
-    ridatadir = File.join(CONFIG['ridir'], CONFIG['ruby_version'], "system")
+    ridatadir = File.join(CONFIG['ridir'], CONFIG['ruby_version_dir_name'] || CONFIG['ruby_version'], "system")
     prepare "rdoc", ridatadir
     install_recursive($rdocdir, ridatadir, :no_install => rdoc_noinst, :mode => $data_mode)
   end