--- ./dln.c_orig        2026-04-30 01:14:28.813436691 -0500
+++ ./dln.c     2026-04-30 01:15:03.413437494 -0500
@@ -107,7 +107,7 @@
 #define isdirsep(x) ((x) == '/')
 #endif

-#if defined(_WIN32) || defined(USE_DLN_DLOPEN)
+#if defined(_WIN32) || defined(_AIX) || defined(USE_DLN_DLOPEN)
 struct string_part {
     const char *ptr;
     size_t len;