--- ./Makefile.in_orig	2026-08-05 00:13:45.195474170 -0500
+++ ./Makefile.in	2026-08-05 00:13:31.895498783 -0500
@@ -101,7 +101,7 @@
 LDFLAGS.shlib = @SH_LDFLAGS@
 LDFLAGS.zlib = @LDFLAGS_ZLIB@
 LDFLAGS.math = @LDFLAGS_MATH@
-LDFLAGS.rpath = @LDFLAGS_RPATH@
+LDFLAGS.rpath =
 LDFLAGS.pthread = @LDFLAGS_PTHREAD@
 LDFLAGS.dlopen = @LDFLAGS_DLOPEN@
 LDFLAGS.readline = @LDFLAGS_READLINE@
--- ./main.mk_orig	2026-08-04 23:23:02.766395206 -0500
+++ ./main.mk	2026-08-04 23:29:17.666000500 -0500
@@ -164,7 +164,7 @@
 #
 LDFLAGS.zlib ?= -lz
 LDFLAGS.math ?= -lm
-LDFLAGS.rpath ?= -Wl,-rpath -Wl,$(prefix)/lib
+LDFLAGS.rpath ?=
 LDFLAGS.pthread ?= -lpthread
 LDFLAGS.dlopen ?= -ldl
 LDFLAGS.shlib ?= -shared
@@ -1641,7 +1641,7 @@
 	$(T.tcl.env.source); \
 	$(T.link.shared) -o $@ tclsqlite.o \
 		$$TCL_INCLUDE_SPEC $$TCL_STUB_LIB_SPEC $(LDFLAGS.libsqlite3) \
-		$(LIBOBJ) -Wl,-rpath,$$TCLLIBDIR
+		$(LIBOBJ)
 # ^^^ that rpath bit is defined as TCL_LD_SEARCH_FLAGS in
 # tclConfig.sh, but it's defined in such a way as to be useless for a
 # _static_ makefile.