--- ./test/testrunner.tcl_orig	2026-08-04 23:38:03.091770414 -0500
+++ ./test/testrunner.tcl	2026-08-04 23:38:50.575489784 -0500
@@ -280,6 +280,15 @@
     set TRG(run)         run.sh
     set TRG(runcmd)      "sh run.sh"
   }
+  *AIX* {
+    set TRG(platform)    linux
+    set TRG(make)        make.sh
+    set TRG(makecmd)     "sh make.sh"
+    set TRG(testfixture) testfixture
+    set TRG(shell)       sqlite3
+    set TRG(run)         run.sh
+    set TRG(runcmd)      "sh run.sh"
+  }
   *win* {
     set TRG(platform)    win
     set TRG(make)        make.bat