--- ./main.mk_orig	2026-08-12 02:57:35.114931272 -0500
+++ ./main.mk	2026-08-12 03:00:18.345500578 -0500
@@ -1558,9 +1558,8 @@
 	@echo "Setting up $(libsqlite3.DLL) version symlinks..."; \
 	cd "$(install-dir.lib)" || exit $$?; \
 	rm -f $(libsqlite3.DLL).0 $(libsqlite3.DLL).$(PACKAGE_VERSION) || exit $$?; \
-	mv $(libsqlite3.DLL) $(libsqlite3.DLL).$(PACKAGE_VERSION) || exit $$?; \
-	ln -s $(libsqlite3.DLL).$(PACKAGE_VERSION) $(libsqlite3.DLL) || exit $$?; \
-	ln -s $(libsqlite3.DLL).$(PACKAGE_VERSION) $(libsqlite3.DLL).0 || exit $$?; \
+	mv $(libsqlite3.DLL) $(libsqlite3.DLL).0 || exit $$?; \
+	ln -s $(libsqlite3.DLL).0 $(libsqlite3.DLL) || exit $$?; \
 	ls -la $(libsqlite3.DLL) $(libsqlite3.DLL).[a03]*; \
 	if [ -e $(libsqlite3.DLL).0.8.6 ]; then \
 		echo "ACHTUNG: legacy libtool-compatible install found. Re-linking it..."; \