--- ./configure_orig	2026-01-08 01:25:10.074271359 -0500
+++ ./configure	2026-01-08 01:32:48.519754726 -0500
@@ -13484,7 +13484,7 @@
   aix_libpath=$lt_cv_aix_libpath_
 fi
 
-	 hardcode_libdir_flag_spec='$wl-blibpath:$libdir:'"$aix_libpath"
+	 hardcode_libdir_flag_spec='$wl-blibpath:'"$aix_libpath"
 	  # Warning - without using the other run time loading flags,
 	  # -berok will link without error, but may produce a broken library.
 	  no_undefined_flag=' $wl-bernotok'
@@ -29115,7 +29115,7 @@
         # the current directory just one below ivykis
 
         IVYKIS_CFLAGS="-isystem \$(top_srcdir)/lib/ivykis/src/include -isystem \$(top_builddir)/lib/ivykis/src/include"
-        IVYKIS_LIBS="-Wl,${WHOLE_ARCHIVE_OPT} -L\$(top_builddir)/lib/ivykis/src -livykis -Wl,${NO_WHOLE_ARCHIVE_OPT}"
+        IVYKIS_LIBS="-livykis"
         INTERNAL_IVYKIS_CFLAGS="-isystem \${includedir}/syslog-ng/ivykis"
 
         IVYKIS_VERSION_UPDATED="yes"
--- ./Makefile.in_orig	2026-01-08 01:25:22.888386855 -0500
+++ ./Makefile.in	2026-01-08 01:33:04.054921527 -0500
@@ -14945,7 +14945,7 @@
 	modules/afsocket/$(DEPDIR)/$(am__dirstamp)
 
 modules/afsocket/libafsocket.la: $(modules_afsocket_libafsocket_la_OBJECTS) $(modules_afsocket_libafsocket_la_DEPENDENCIES) $(EXTRA_modules_afsocket_libafsocket_la_DEPENDENCIES) modules/afsocket/$(am__dirstamp)
-	$(AM_V_CCLD)$(modules_afsocket_libafsocket_la_LINK) -rpath $(moduledir) $(modules_afsocket_libafsocket_la_OBJECTS) $(modules_afsocket_libafsocket_la_LIBADD) $(LIBS)
+	$(AM_V_CCLD)$(modules_afsocket_libafsocket_la_LINK) -rpath $(moduledir) $(modules_afsocket_libafsocket_la_OBJECTS) $(modules_afsocket_libafsocket_la_LIBADD) $(LIBS) $(IVYKIS_LIBS)
 modules/afsql/$(am__dirstamp):
 	@$(MKDIR_P) modules/afsql
 	@: >>modules/afsql/$(am__dirstamp)
@@ -15245,7 +15245,7 @@
 	modules/correlation/$(DEPDIR)/$(am__dirstamp)
 
 modules/correlation/libcorrelation.la: $(modules_correlation_libcorrelation_la_OBJECTS) $(modules_correlation_libcorrelation_la_DEPENDENCIES) $(EXTRA_modules_correlation_libcorrelation_la_DEPENDENCIES) modules/correlation/$(am__dirstamp)
-	$(AM_V_CCLD)$(modules_correlation_libcorrelation_la_LINK) -rpath $(moduledir) $(modules_correlation_libcorrelation_la_OBJECTS) $(modules_correlation_libcorrelation_la_LIBADD) $(LIBS)
+	$(AM_V_CCLD)$(modules_correlation_libcorrelation_la_LINK) -rpath $(moduledir) $(modules_correlation_libcorrelation_la_OBJECTS) $(modules_correlation_libcorrelation_la_LIBADD) $(LIBS) $(IVYKIS_LIBS)
 modules/correlation/libsyslog_ng_patterndb_la-radix.lo:  \
 	modules/correlation/$(am__dirstamp) \
 	modules/correlation/$(DEPDIR)/$(am__dirstamp)
@@ -15392,7 +15392,7 @@
 	modules/diskq/$(DEPDIR)/$(am__dirstamp)
 
 modules/diskq/libdisk-buffer.la: $(modules_diskq_libdisk_buffer_la_OBJECTS) $(modules_diskq_libdisk_buffer_la_DEPENDENCIES) $(EXTRA_modules_diskq_libdisk_buffer_la_DEPENDENCIES) modules/diskq/$(am__dirstamp)
-	$(AM_V_CCLD)$(modules_diskq_libdisk_buffer_la_LINK) -rpath $(moduledir) $(modules_diskq_libdisk_buffer_la_OBJECTS) $(modules_diskq_libdisk_buffer_la_LIBADD) $(LIBS)
+	$(AM_V_CCLD)$(modules_diskq_libdisk_buffer_la_LINK) -rpath $(moduledir) $(modules_diskq_libdisk_buffer_la_OBJECTS) $(modules_diskq_libdisk_buffer_la_LIBADD) $(LIBS) $(IVYKIS_LIBS) -lbsd
 modules/diskq/libsyslog_ng_disk_buffer_la-diskq-options.lo:  \
 	modules/diskq/$(am__dirstamp) \
 	modules/diskq/$(DEPDIR)/$(am__dirstamp)
@@ -15494,7 +15494,7 @@
 	modules/examples/$(DEPDIR)/$(am__dirstamp)
 
 modules/examples/libexamples.la: $(modules_examples_libexamples_la_OBJECTS) $(modules_examples_libexamples_la_DEPENDENCIES) $(EXTRA_modules_examples_libexamples_la_DEPENDENCIES) modules/examples/$(am__dirstamp)
-	$(AM_V_CXXLD)$(modules_examples_libexamples_la_LINK) $(am_modules_examples_libexamples_la_rpath) $(modules_examples_libexamples_la_OBJECTS) $(modules_examples_libexamples_la_LIBADD) $(LIBS)
+	$(AM_V_CXXLD)$(modules_examples_libexamples_la_LINK) $(am_modules_examples_libexamples_la_rpath) $(modules_examples_libexamples_la_OBJECTS) $(modules_examples_libexamples_la_LIBADD) $(LIBS) $(IVYKIS_LIBS) -lbsd
 modules/examples/sources/msg-generator/$(am__dirstamp):
 	@$(MKDIR_P) modules/examples/sources/msg-generator
 	@: >>modules/examples/sources/msg-generator/$(am__dirstamp)
@@ -16051,7 +16051,7 @@
 	modules/http/$(DEPDIR)/$(am__dirstamp)
 
 modules/http/libhttp.la: $(modules_http_libhttp_la_OBJECTS) $(modules_http_libhttp_la_DEPENDENCIES) $(EXTRA_modules_http_libhttp_la_DEPENDENCIES) modules/http/$(am__dirstamp)
-	$(AM_V_CCLD)$(modules_http_libhttp_la_LINK) $(am_modules_http_libhttp_la_rpath) $(modules_http_libhttp_la_OBJECTS) $(modules_http_libhttp_la_LIBADD) $(LIBS)
+	$(AM_V_CCLD)$(modules_http_libhttp_la_LINK) $(am_modules_http_libhttp_la_rpath) $(modules_http_libhttp_la_OBJECTS) $(modules_http_libhttp_la_LIBADD) $(LIBS) $(IVYKIS_LIBS) -L/opt/freeware/lib -lz
 modules/java/native/$(am__dirstamp):
 	@$(MKDIR_P) modules/java/native
 	@: >>modules/java/native/$(am__dirstamp)
@@ -16473,7 +16473,7 @@
 	modules/rate-limit-filter/$(DEPDIR)/$(am__dirstamp)
 
 modules/rate-limit-filter/librate-limit-filter.la: $(modules_rate_limit_filter_librate_limit_filter_la_OBJECTS) $(modules_rate_limit_filter_librate_limit_filter_la_DEPENDENCIES) $(EXTRA_modules_rate_limit_filter_librate_limit_filter_la_DEPENDENCIES) modules/rate-limit-filter/$(am__dirstamp)
-	$(AM_V_CCLD)$(modules_rate_limit_filter_librate_limit_filter_la_LINK) -rpath $(moduledir) $(modules_rate_limit_filter_librate_limit_filter_la_OBJECTS) $(modules_rate_limit_filter_librate_limit_filter_la_LIBADD) $(LIBS)
+	$(AM_V_CCLD)$(modules_rate_limit_filter_librate_limit_filter_la_LINK) -rpath $(moduledir) $(modules_rate_limit_filter_librate_limit_filter_la_OBJECTS) $(modules_rate_limit_filter_librate_limit_filter_la_LIBADD) $(LIBS) $(IVYKIS_LIBS)
 modules/redis/$(am__dirstamp):
 	@$(MKDIR_P) modules/redis
 	@: >>modules/redis/$(am__dirstamp)
@@ -16607,7 +16607,7 @@
 	modules/system-source/$(DEPDIR)/$(am__dirstamp)
 
 modules/system-source/libsystem-source.la: $(modules_system_source_libsystem_source_la_OBJECTS) $(modules_system_source_libsystem_source_la_DEPENDENCIES) $(EXTRA_modules_system_source_libsystem_source_la_DEPENDENCIES) modules/system-source/$(am__dirstamp)
-	$(AM_V_CCLD)$(modules_system_source_libsystem_source_la_LINK) -rpath $(moduledir) $(modules_system_source_libsystem_source_la_OBJECTS) $(modules_system_source_libsystem_source_la_LIBADD) $(LIBS)
+	$(AM_V_CCLD)$(modules_system_source_libsystem_source_la_LINK) -rpath $(moduledir) $(modules_system_source_libsystem_source_la_OBJECTS) $(modules_system_source_libsystem_source_la_LIBADD) $(LIBS) $(IVYKIS_LIBS)
 modules/systemd-journal/$(am__dirstamp):
 	@$(MKDIR_P) modules/systemd-journal
 	@: >>modules/systemd-journal/$(am__dirstamp)
@@ -18154,7 +18154,7 @@
 
 modules/diskq/dqtool$(EXEEXT): $(modules_diskq_dqtool_OBJECTS) $(modules_diskq_dqtool_DEPENDENCIES) $(EXTRA_modules_diskq_dqtool_DEPENDENCIES) modules/diskq/$(am__dirstamp)
 	@rm -f modules/diskq/dqtool$(EXEEXT)
-	$(AM_V_CCLD)$(LINK) $(modules_diskq_dqtool_OBJECTS) $(modules_diskq_dqtool_LDADD) $(LIBS)
+	$(AM_V_CCLD)$(LINK) $(modules_diskq_dqtool_OBJECTS) $(modules_diskq_dqtool_LDADD) $(LIBS) -lbsd
 modules/diskq/tests/$(am__dirstamp):
 	@$(MKDIR_P) modules/diskq/tests
 	@: >>modules/diskq/tests/$(am__dirstamp)