--- ./Makefile.in_orig	2025-03-03 02:04:43.148103708 -0500
+++ ./Makefile.in	2025-03-03 02:10:16.908354518 -0500
@@ -15456,7 +15456,7 @@
 	modules/afsocket/$(DEPDIR)/$(am__dirstamp)
 
 modules/afsocket/libafsocket.la: $(modules_afsocket_libafsocket_la_OBJECTS) $(modules_afsocket_libafsocket_la_DEPENDENCIES) $(EXTRA_modules_afsocket_libafsocket_la_DEPENDENCIES) modules/afsocket/$(am__dirstamp)
-	$(AM_V_CCLD)$(modules_afsocket_libafsocket_la_LINK) -rpath $(moduledir) $(modules_afsocket_libafsocket_la_OBJECTS) $(modules_afsocket_libafsocket_la_LIBADD) $(LIBS)
+	$(AM_V_CCLD)$(modules_afsocket_libafsocket_la_LINK) -rpath $(moduledir) $(modules_afsocket_libafsocket_la_OBJECTS) $(modules_afsocket_libafsocket_la_LIBADD) $(LIBS) $(IVYKIS_LIBS)
 modules/afsql/$(am__dirstamp):
 	@$(MKDIR_P) modules/afsql
 	@: > modules/afsql/$(am__dirstamp)
@@ -15753,7 +15753,7 @@
 	modules/correlation/$(DEPDIR)/$(am__dirstamp)
 
 modules/correlation/libcorrelation.la: $(modules_correlation_libcorrelation_la_OBJECTS) $(modules_correlation_libcorrelation_la_DEPENDENCIES) $(EXTRA_modules_correlation_libcorrelation_la_DEPENDENCIES) modules/correlation/$(am__dirstamp)
-	$(AM_V_CCLD)$(modules_correlation_libcorrelation_la_LINK) -rpath $(moduledir) $(modules_correlation_libcorrelation_la_OBJECTS) $(modules_correlation_libcorrelation_la_LIBADD) $(LIBS)
+	$(AM_V_CCLD)$(modules_correlation_libcorrelation_la_LINK) -rpath $(moduledir) $(modules_correlation_libcorrelation_la_OBJECTS) $(modules_correlation_libcorrelation_la_LIBADD) $(LIBS) $(IVYKIS_LIBS)
 modules/correlation/libsyslog_ng_patterndb_la-radix.lo:  \
 	modules/correlation/$(am__dirstamp) \
 	modules/correlation/$(DEPDIR)/$(am__dirstamp)
@@ -15900,7 +15900,7 @@
 	modules/diskq/$(DEPDIR)/$(am__dirstamp)
 
 modules/diskq/libdisk-buffer.la: $(modules_diskq_libdisk_buffer_la_OBJECTS) $(modules_diskq_libdisk_buffer_la_DEPENDENCIES) $(EXTRA_modules_diskq_libdisk_buffer_la_DEPENDENCIES) modules/diskq/$(am__dirstamp)
-	$(AM_V_CCLD)$(modules_diskq_libdisk_buffer_la_LINK) -rpath $(moduledir) $(modules_diskq_libdisk_buffer_la_OBJECTS) $(modules_diskq_libdisk_buffer_la_LIBADD) $(LIBS)
+	$(AM_V_CCLD)$(modules_diskq_libdisk_buffer_la_LINK) -rpath $(moduledir) $(modules_diskq_libdisk_buffer_la_OBJECTS) $(modules_diskq_libdisk_buffer_la_LIBADD) $(LIBS) $(IVYKIS_LIBS) -lbsd
 modules/diskq/libsyslog_ng_disk_buffer_la-diskq-options.lo:  \
 	modules/diskq/$(am__dirstamp) \
 	modules/diskq/$(DEPDIR)/$(am__dirstamp)
@@ -16014,7 +16014,7 @@
 	modules/examples/$(DEPDIR)/$(am__dirstamp)
 
 modules/examples/libexamples.la: $(modules_examples_libexamples_la_OBJECTS) $(modules_examples_libexamples_la_DEPENDENCIES) $(EXTRA_modules_examples_libexamples_la_DEPENDENCIES) modules/examples/$(am__dirstamp)
-	$(AM_V_CXXLD)$(modules_examples_libexamples_la_LINK) $(am_modules_examples_libexamples_la_rpath) $(modules_examples_libexamples_la_OBJECTS) $(modules_examples_libexamples_la_LIBADD) $(LIBS)
+	$(AM_V_CXXLD)$(modules_examples_libexamples_la_LINK) $(am_modules_examples_libexamples_la_rpath) $(modules_examples_libexamples_la_OBJECTS) $(modules_examples_libexamples_la_LIBADD) $(LIBS) $(IVYKIS_LIBS) -lbsd
 modules/examples/sources/msg-generator/$(am__dirstamp):
 	@$(MKDIR_P) modules/examples/sources/msg-generator
 	@: > modules/examples/sources/msg-generator/$(am__dirstamp)
@@ -16496,7 +16496,7 @@
 	modules/http/$(DEPDIR)/$(am__dirstamp)
 
 modules/http/libhttp.la: $(modules_http_libhttp_la_OBJECTS) $(modules_http_libhttp_la_DEPENDENCIES) $(EXTRA_modules_http_libhttp_la_DEPENDENCIES) modules/http/$(am__dirstamp)
-	$(AM_V_CCLD)$(modules_http_libhttp_la_LINK) $(am_modules_http_libhttp_la_rpath) $(modules_http_libhttp_la_OBJECTS) $(modules_http_libhttp_la_LIBADD) $(LIBS)
+	$(AM_V_CCLD)$(modules_http_libhttp_la_LINK) $(am_modules_http_libhttp_la_rpath) $(modules_http_libhttp_la_OBJECTS) $(modules_http_libhttp_la_LIBADD) $(LIBS) $(IVYKIS_LIBS) -L/opt/freeware/lib -lz
 modules/java/native/$(am__dirstamp):
 	@$(MKDIR_P) modules/java/native
 	@: > modules/java/native/$(am__dirstamp)
@@ -16930,7 +16930,7 @@
 	modules/rate-limit-filter/$(DEPDIR)/$(am__dirstamp)
 
 modules/rate-limit-filter/librate-limit-filter.la: $(modules_rate_limit_filter_librate_limit_filter_la_OBJECTS) $(modules_rate_limit_filter_librate_limit_filter_la_DEPENDENCIES) $(EXTRA_modules_rate_limit_filter_librate_limit_filter_la_DEPENDENCIES) modules/rate-limit-filter/$(am__dirstamp)
-	$(AM_V_CCLD)$(modules_rate_limit_filter_librate_limit_filter_la_LINK) -rpath $(moduledir) $(modules_rate_limit_filter_librate_limit_filter_la_OBJECTS) $(modules_rate_limit_filter_librate_limit_filter_la_LIBADD) $(LIBS)
+	$(AM_V_CCLD)$(modules_rate_limit_filter_librate_limit_filter_la_LINK) -rpath $(moduledir) $(modules_rate_limit_filter_librate_limit_filter_la_OBJECTS) $(modules_rate_limit_filter_librate_limit_filter_la_LIBADD) $(LIBS) $(IVYKIS_LIBS)
 modules/redis/$(am__dirstamp):
 	@$(MKDIR_P) modules/redis
 	@: > modules/redis/$(am__dirstamp)
@@ -17064,7 +17064,7 @@
 	modules/system-source/$(DEPDIR)/$(am__dirstamp)
 
 modules/system-source/libsystem-source.la: $(modules_system_source_libsystem_source_la_OBJECTS) $(modules_system_source_libsystem_source_la_DEPENDENCIES) $(EXTRA_modules_system_source_libsystem_source_la_DEPENDENCIES) modules/system-source/$(am__dirstamp)
-	$(AM_V_CCLD)$(modules_system_source_libsystem_source_la_LINK) -rpath $(moduledir) $(modules_system_source_libsystem_source_la_OBJECTS) $(modules_system_source_libsystem_source_la_LIBADD) $(LIBS)
+	$(AM_V_CCLD)$(modules_system_source_libsystem_source_la_LINK) -rpath $(moduledir) $(modules_system_source_libsystem_source_la_OBJECTS) $(modules_system_source_libsystem_source_la_LIBADD) $(LIBS) $(IVYKIS_LIBS)
 modules/systemd-journal/$(am__dirstamp):
 	@$(MKDIR_P) modules/systemd-journal
 	@: > modules/systemd-journal/$(am__dirstamp)
@@ -18741,7 +18741,7 @@
 
 modules/diskq/dqtool$(EXEEXT): $(modules_diskq_dqtool_OBJECTS) $(modules_diskq_dqtool_DEPENDENCIES) $(EXTRA_modules_diskq_dqtool_DEPENDENCIES) modules/diskq/$(am__dirstamp)
 	@rm -f modules/diskq/dqtool$(EXEEXT)
-	$(AM_V_CCLD)$(LINK) $(modules_diskq_dqtool_OBJECTS) $(modules_diskq_dqtool_LDADD) $(LIBS)
+	$(AM_V_CCLD)$(LINK) $(modules_diskq_dqtool_OBJECTS) $(modules_diskq_dqtool_LDADD) $(LIBS) -lbsd
 modules/diskq/tests/$(am__dirstamp):
 	@$(MKDIR_P) modules/diskq/tests
 	@: > modules/diskq/tests/$(am__dirstamp)
--- ./configure_orig	2025-03-03 08:32:40.824720379 -0500
+++ ./configure	2025-03-03 07:25:11.130027895 -0500
@@ -32244,7 +32244,7 @@
 		# these can only be used in lib as it assumes
 		# the current directory just one below ivykis
 
-		IVYKIS_LIBS="-Wl,${WHOLE_ARCHIVE_OPT} -L\$(top_builddir)/lib/ivykis/src -livykis -Wl,${NO_WHOLE_ARCHIVE_OPT}"
+		IVYKIS_LIBS="-L\$(top_builddir)/lib/ivykis/src -livykis"
 		IVYKIS_CFLAGS="-isystem \$(top_srcdir)/lib/ivykis/src/include -isystem \$(top_builddir)/lib/ivykis/src/include"
                 INTERNAL_IVYKIS_CFLAGS="-isystem \${includedir}/syslog-ng/ivykis"
 